﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace WindowsFormsApplication1
{
  
    public class TGauss
    {
        public int order = 4;
       
        public double[,] a;
        public double[] y;
        public double[] x;
        private int[] index;

        public TGauss(int size)
        {
            int l;
            order = size;
            a = new double[order, order];
            y = new double[order];
            x = new double[order];
            index = new int[order];
            for (l = 0; l < order; l++)
            {
                index[l] = l;
                x[l] = 0.0;
                y[l] = 0.0;
            }
        }


        void SwitchColumns(int n)
        {
            double tempD;
            int i, j, temoI;
            for (i = n; i <= order - 2; i++)
            {
                for (j = 0; j <= order - 1; j++)
                {
                    tempD = a[j, i];
                    a[j, i] = a[j, i + 1];
                    a[j, i + 1] = tempD;
                }
                temoI = index[i];
                index[i] = index[i+1];
                index[i + 1] = temoI;
            
            }
        }

        void Reorder()
        {
            int i;
            double[] tempVal = new double[order];
            for (i = 0; i < order; i++)
            {
                if (index[i] < order)
                {
                    tempVal[index[i]] = x[i];
                }
            }
            for (i = 0; i < order; i++)
            {
               x[i] = tempVal[i];
            }
        }

        public bool Eliminate(int empties)
        {
            int i, k, l;
            bool calcError = false;
            i = 1;
            for (l = 0; l < order; l++)
            {
                index[l] = l;
                x[l] = 0.0;
                y[l] = 0.0;
            }
            for (k = 0; k <= order - 1 - empties; k++)
            {
                l = k + 1;
                while ((Math.Abs(a[k, k]) < 1e-8) && (l < order))
                {
                    SwitchColumns(k);
                    l++;
                }
                if (l < order)
                {
                    for (i = k; i <= order - 2; i++)
                    {
                        if (!calcError)
                        {
                            if (Math.Abs(a[i + 1, k]) > 1e-8)
                            {
                                for (l = k + 1; l <= order - 1; l++)
                                {
                                    a[i + 1, l] = a[i + 1, l] * a[k, k] - a[k, l] * a[i + 1, k];
                                }
                                y[i + 1] = y[i + 1] * a[k, k] - y[k] * a[i + 1, k];
                                a[i + 1, k] = 0;
                            }
                        }
                    }
                }
                else
                    calcError = true;
            }
            return !calcError;
        }

        public void Solve(int empties)
        {
            int k, l;
            for (l = order - 1; l > order - empties - 1; l--)
                x[l] = 1.0;
            for (k = order - empties - 1; k >= 0; k--)
            {
                for (l = order - 1; l > k; l--)
                {
                    y[k] = y[k] - x[l] * a[k, l];
                }
               x[k] = y[k] / a[k, k];
            }
            Reorder();
        }
    }
}
